=== debian/changelog ===
simgear (1:2020.3.19+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Dmitry Shachnev ]
  * Backport upstream fixes for Boost 1.88 (closes: #1125271).

  [ Dr. Tobias Quathamer ]
  * Update d/watch to version 5
  * Remove Rules-Requires-Root from d/control
  * Update homepage
  * Remove Priority: optional from d/control
  * Update Standards-Version to 4.7.3

 -- Dr. Tobias Quathamer <toddy@debian.org>  Thu, 15 Jan 2026 16:47:44 +0100

simgear (1:2020.3.19+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113503)

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Oct 2025 14:10:57 +0200

simgear (1:2020.3.19+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2020.3.19+dfsg
    - New patch: check I/O rules when auto-constructing an SGPath from
      a Nasal scalar. Thanks to Florent Rougon <f.rougon@frougon.net>
      (CVE-2025-0781)
  * Update Standards-Version to 4.7.0, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 26 Jan 2025 01:03:37 +0100
