=== debian/watch ===
Version: 5
Source: https://gitlab.com/api/v4/projects/flightgear%2F@PACKAGE@/repository/tags
Matching-Pattern: https://gitlab.com/flightgear/@PACKAGE@/.*/@PACKAGE@-v?@STABLE_VERSION@@ARCHIVE_EXT@
Pagemangle: s!"name":"(v?@ANY_VERSION@)"!<a href="https://gitlab.com/flightgear/@PACKAGE@/-/archive/$1/@PACKAGE@-$1.tar.bz2">!g
Dversion-Mangle: auto
Repack-Suffix: +dfsg
