=== debian/changelog ===
simgear (1:2024.1.3+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2024.1.3+dfsg
    - Remove patches which have been applied upstream
    - Refresh patches
    - Add new patch to use system library tinyGLTF
    - Add new patch to add EXPAT as dependency to simgear library
    - Add new build dependencies
  * Use wrap-and-sort -astkb

 -- Dr. Tobias Quathamer <toddy@debian.org>  Fri, 16 Jan 2026 23:54:18 +0100
