=== debian/changelog ===
simgear (1:2024.1.4+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2024.1.4+dfsg
    - Refresh patches

 -- Dr. Tobias Quathamer <toddy@debian.org>  Fri, 30 Jan 2026 16:15:51 +0100
