=== debian/control ===
Source: simgear
Section: libs
Maintainer: Debian FlightGear Crew <team+flightgear@tracker.debian.org>
Uploaders:
 Ove Kaaven <ovek@arcticnet.no>,
 Markus Wanner <markus@bluegap.ch>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libboost-dev,
 libc-ares-dev,
 libcurl4-gnutls-dev,
 libexpat1-dev,
 libgl-dev,
 libglu1-mesa-dev,
 liblzma-dev,
 libopenal-dev,
 libopenscenegraph-dev,
 libtinygltf-dev,
 libudns-dev,
 libutfcpp-dev,
 netbase,
 nlohmann-json3-dev,
 zlib1g-dev,
Standards-Version: 4.7.3
Homepage: https://www.flightgear.org/
Vcs-Browser: https://salsa.debian.org/debian/simgear
Vcs-Git: https://salsa.debian.org/debian/simgear.git

Package: libsimgear-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libc6-dev,
 libopenscenegraph-dev,
 ${misc:Depends},
Description: Simulator Construction Gear -- development files
 SimGear is a collection of libraries useful for constructing
 simulation and visualization applications such as FlightGear
 or TerraGear.
 .
 This package contains the headers and static libraries.
